<?php

set_include_path(get_include_path() . PATH_SEPARATOR . '../../include');

require 'config.inc.php';

// Connect to database
list($db_ext, $db_sub) = explode(':', $CONFIG['dbtype'].':');
$db_ext = $db_ext ?: 'mysqli';
require 'database/'.$db_ext.'/dbase.inc.php';
$CPGDB = new CPG_Dbase($CONFIG);

if (!$CPGDB->isConnected()) {
    die('FAILED: unable to connect to database!'."\n".$CPGDB->db_type.' said: ' . $CPGDB->getError());
}

require 'functions.inc.php';

// Retrieve DB stored configuration
$cfg_tbl = $CONFIG['TABLE_PREFIX'].'config';
$result = $CPGDB->query("SELECT name, value FROM {$cfg_tbl}");
if (!$result) die('FAILED: unable to read config from database!'."\n".$CPGDB->db_type.' said: ' . $CPGDB->getError());
while ( ($row = $result->fetchAssoc()) ) {
    $CONFIG[$row['name']] = $row['value'];
} // while
$result->free();

if (empty($_POST['imgBase64'])) die('FAILED: server received no image data');
$mtch = [];
if (!preg_match('#^data:image/(\w*);base64,#', $_POST['imgBase64'], $mtch)) die('FAILED: could not parse image data');
if ($mtch[1]=='jpeg') $mtch[1] = 'jpg';
$fimgp = '../../'.$CONFIG['fullpath'].'edit/video_image_'.time().'.'.$mtch[1];
if (!file_put_contents($fimgp, base64_decode(substr($_POST['imgBase64'], strlen($mtch[0]))))) die('FAILED: could not save thumbnail');

$pid = (int) $_POST['pid'];
$result = $CPGDB->query("SELECT * FROM {$CONFIG['TABLE_PREFIX']}pictures WHERE pid={$pid} LIMIT 1");
if (!$result->numRows()) die('FAILED: no such image in database');
$row = $result->fetchAssoc(true);

$tfnam = pathinfo($row['filename'])['filename'];
$thumb = '../../'.$CONFIG['fullpath'] . $row['filepath'] . $CONFIG['thumb_pfx'] . $tfnam .'.'. $mtch[1];
if (!rename($fimgp, $thumb)) die('FAILED: could not place thumbnail');
